import { ConditionClause, Mapping } from 'typed-sql';
import { ComparisonValueType } from 'typed-sql/lib/condition';
import { Attribute } from 'typed-sql/lib/mapping';
import { CustomError } from './common';
export interface Join<T, U> {
    masterMapping: Mapping<T>;
    detailMapping: Mapping<U>;
    joinCondition: ConditionClause;
}
export declare type JoinPath = Join<{}, {}>[];
export declare class SqlGraph {
    private graph;
    constructor();
    addMasterDetailJoin<T, U>(masterMapping: Mapping<T>, detailMapping: Mapping<U>, joinCondition: ConditionClause): Join<T, U>;
    addSimpleMasterDetailJoin<T extends ComparisonValueType>(masterAttribute: Attribute<T>, detailAttribute: Attribute<T>): Join<{}, {}>;
    addJoin<T, U>(join: Join<T, U>): void;
    /**
     * Return a list of joins linking the source relation to the target.
     */
    getJoinPath<T, U>(sourceMapping: Mapping<T>, targetMapping: Mapping<U>): JoinPath;
    private getNodeMapping(tableName);
    private getEdgeJoinCondition(sourceTableName, targetTableName);
}
export declare class SqlGraphTopologyError extends CustomError {
}
